#include "sys.h"

//ϵͳʱ
void RCC_Configuration(void)
{
	ErrorStatus HSEStartUpStatus;                    //ⲿپ״̬öٱ

	RCC_DeInit();                                    //λRCCⲿ豸ĴĬֵ
	RCC_HSEConfig(RCC_HSE_ON);                       //ⲿپ
	HSEStartUpStatus = RCC_WaitForHSEStartUp();      //ȴⲿʱ׼
	if(HSEStartUpStatus == SUCCESS)                  //ⲿʱѾ׼
	{
		FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable); //FLASHԤ幦ܣFLASHĶȡгб÷.λãRCCʼӺ棬ʱ֮
		FLASH_SetLatency(FLASH_Latency_2);                    //flashʱ
			
		RCC_HCLKConfig(RCC_SYSCLK_Div1);               //AHB(HCLK)ʱӵ==SYSCLK
		RCC_PCLK2Config(RCC_HCLK_Div1);                //APB2(PCLK2)==AHBʱ
		RCC_PCLK1Config(RCC_HCLK_Div2);                //APB1(PCLK1)==AHB1/2ʱ
			 
		RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);  //PLLʱ == ⲿپʱ * 9 = 72MHz
		RCC_PLLCmd(ENABLE);                                   //ʹPLLʱ
   
		while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET)    //ȴPLLʱӾ
		{
		}
		RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);            //ϵͳʱ = PLLʱ
		while(RCC_GetSYSCLKSource() != 0x08)                  //PLLʱǷΪϵͳʱ
		{
		}
	}
}

//IO
//÷ĸǸ
void GPIO_Configuration(void)
{
	GPIO_InitTypeDef   GPIO_InitStructure;   //ΪGPIO_InitStructureĽṹͱ

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);  //GPIOBʱӣʹܡ
	//RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);  //GPIOCʱӣʹܡ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD, ENABLE);  //GPIODʱӣʹܡ
	//RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);  //GPIOAʱӣʹܡ
	//RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOD, ENABLE);  //GPIOBGPIODʱӣʹܡ
	//PD10ڣ
//	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10 | GPIO_Pin_9;              //ѡĸIO ѡPD9ںPD10
//	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU ;                       //趨IOڵģʽΪ몽
//	//GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;	                 //IOڵģʽ룬GPIO_SpeedԲֵ
//	GPIO_Init(GPIOD, &GPIO_InitStructure);	/* PC6 */                    //ʼGPIOD

	//PAڣ
//	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1;              //ѡĸIO ѡPA0ںPA1
//	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;		             //趨IOڵģʽΪ
//	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;	                 //趨IOڵٶΪ2MHz
//	GPIO_Init(GPIOA, &GPIO_InitStructure);	/* PC6 */                    //ʼGPIOD
	
	//PDڣ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3;              //ѡĸIO ѡPD0123
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;		             //趨IOڵģʽΪ
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;	                 //趨IOڵٶΪ50MHz
	GPIO_Init(GPIOD, &GPIO_InitStructure);	                             //ʼGPIOD

	//PDڣ
//	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;              //ѡĸIO ѡPD2
//	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;		             //趨IOڵģʽΪ
//	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;	                 //趨IOڵٶΪ2MHz
//	GPIO_Init(GPIOD, &GPIO_InitStructure);	/* PC6 */                    //ʼGPIOD

	//3LEDƣPB12PB13PB14
	GPIO_SetBits(GPIOB,  GPIO_Pin_0 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14);	         //ر3LEDƣPB12PB13PB14ߵƽ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14;	             //ѡPB12PB13PB14
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;		             //趨IOڵģʽΪ
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;		             //趨IOڵٶΪ2MHz
	GPIO_Init(GPIOB, &GPIO_InitStructure);					             //ʼGPIOB
}

//жIO
//÷ĸǸ
void EXTI_Configuration(void)
{
	EXTI_InitTypeDef EXTI_InitStructure;						   //һṹ

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE); 		   //APB2߸ʱ
	
	//ⲿж10ã
	EXTI_ClearITPendingBit(EXTI_Line10);						   //жϹλ ⲿж10
	EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;		       //ѡжϴ¼ѡжϴ
	EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;	       //ʽѡ½ش
	EXTI_InitStructure.EXTI_Line = EXTI_Line10;				       //ѡĸIOΪж룬ѡPD10
	EXTI_InitStructure.EXTI_LineCmd = ENABLE;					   //ʹж
	EXTI_Init(&EXTI_InitStructure);							       //EXTI_InitStructָĲʼEXTIĴ
	GPIO_EXTILineConfig(GPIO_PortSourceGPIOD, GPIO_PinSource10);   //ѡGPIOܽΪⲿж·
	//ⲿж9ã
	EXTI_ClearITPendingBit(EXTI_Line9);						       //жϹλ ⲿж9
	EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;		       //ѡжϴ¼ѡжϴ
	EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;	       //ʽѡ½ش
	EXTI_InitStructure.EXTI_Line = EXTI_Line9;				       //ѡĸIOΪж룬ѡPD9
	EXTI_InitStructure.EXTI_LineCmd = ENABLE;					   //ʹж
	EXTI_Init(&EXTI_InitStructure);							       //EXTI_InitStructָĲʼEXTIĴ
	GPIO_EXTILineConfig(GPIO_PortSourceGPIOD, GPIO_PinSource9);    //ѡGPIOܽΪⲿж·
}

//жȼ
//÷ĸǸ
void NVIC_Configuration(void)
{
	NVIC_InitTypeDef    NVIC_InitStructure; 					   //жϵĽṹ

	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);                //жȼ  ռʽȼΪ2λӦȼռ2λ
	
	//ⲿж10ȼ
//	NVIC_InitStructure.NVIC_IRQChannel = EXTI15_10_IRQn;           //ָжԴ
//	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;	   //ռȼ1
//	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;             //ָӦȼ1
//	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;	               //ʹⲿжͨ
//	NVIC_Init(&NVIC_InitStructure);							       //NVIC_InitStructָĲʼNVICĴ
	//ⲿж9ȼ
//	NVIC_InitStructure.NVIC_IRQChannel = EXTI9_5_IRQn;             //ָжԴ  
//	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;	   //ռȼ ʱû
//	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;             //ָӦȼ2
//	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;	               //ʹⲿжͨ
//	NVIC_Init(&NVIC_InitStructure);							       //NVIC_InitStructָĲʼNVICĴ
	//1жȼ
//	NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;              //ͨΪ1ж  
//	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;	   //ռȼ1
//	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;             //ָӦȼ1
//	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;	               //ж
//	NVIC_Init(&NVIC_InitStructure);							       //NVIC_InitStructָĲʼNVICĴ
	//1DMAжȼ
//	NVIC_InitStructure.NVIC_IRQChannel = DMA1_Channel4_IRQn;       //ͨΪDMAͨ4ж  
//	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;	   //ռȼ1
//	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;             //ָӦȼ1
//	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;	               //ж
//	NVIC_Init(&NVIC_InitStructure);							       //NVIC_InitStructָĲʼNVICĴ
	//2жȼ(RS485)
	NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;			   //ָжԴ
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;	   //ռȼ1
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;             //ָӦȼ1
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;	               //ж
	NVIC_Init(&NVIC_InitStructure);							       //NVIC_InitStructָĲʼNVICĴ

	//3жȼ(RS485)
//	NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;			   //ָжԴ
//  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;	   //ռȼ1
//	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;             //ָӦȼ1
//	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;	               //ж
//	NVIC_Init(&NVIC_InitStructure);							       //NVIC_InitStructָĲʼNVICĴ

//	//1DMAȼ
//	NVIC_InitStructure.NVIC_IRQChannel = DMA1_Channel5_IRQn;       //DMA1ͨ5ж 
//	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;	   //ռȼ1
//	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;             //ָӦȼ1
//	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;	               //ж
//	NVIC_Init(&NVIC_InitStructure);							       //NVIC_InitStructָĲʼNVICĴ

//	//4жȼ(RS485)
//	NVIC_InitStructure.NVIC_IRQChannel = UART4_IRQn;			   //ָжԴ
//  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;	   //ռȼ1
//	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;             //ָӦȼ1
//	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;	               //ж
//	NVIC_Init(&NVIC_InitStructure);							       //NVIC_InitStructָĲʼNVICĴ

//	//5жȼ(RS485)
//	NVIC_InitStructure.NVIC_IRQChannel = UART5_IRQn;			   //ָжԴ
//  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;	   //ռȼ1
//	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;             //ָӦȼ1
//	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;	               //ж
//	NVIC_Init(&NVIC_InitStructure);							       //NVIC_InitStructָĲʼNVICĴ

	
	//ͨöʱ2жȼ
//	NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;  //TIM2ж
//	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //ռȼ1
//	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;  //ȼ3
//	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; //IRQͨʹ
//	NVIC_Init(&NVIC_InitStructure);  //ʼNVICĴ	
	
	//ͨöʱ3жȼ
//	NVIC_InitStructure.NVIC_IRQChannel = TIM3_IRQn;  //TIM3ж
//	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;  //ռȼ1
//	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;  //ȼ3
//	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; //IRQͨʹ
//	NVIC_Init(&NVIC_InitStructure);  //ʼNVICĴ
	
	//ͨöʱ4жȼ
//	NVIC_InitStructure.NVIC_IRQChannel = TIM4_IRQn;  //TIM4ж
//	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;  //ռȼ1
//	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;  //ȼ3
//	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; //IRQͨʹ
//	NVIC_Init(&NVIC_InitStructure);  //ʼNVICĴ	
	
	//ͨöʱ5жȼ
//	NVIC_InitStructure.NVIC_IRQChannel = TIM5_IRQn;  //TIM5ж
//	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;  //ռȼ1
//	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;  //ȼ3
//	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; //IRQͨʹ
//	NVIC_Init(&NVIC_InitStructure);  //ʼNVICĴ	
	
	//ͨöʱ6жȼ
//	NVIC_InitStructure.NVIC_IRQChannel = TIM6_IRQn;  //TIM6ж
//	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;  //ռȼ1
//	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;  //ȼ3
//	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; //IRQͨʹ
//	NVIC_Init(&NVIC_InitStructure);  //ʼNVICĴ	
	
	//ͨöʱ7жȼ
//	NVIC_InitStructure.NVIC_IRQChannel = TIM7_IRQn;  //TIM7ж
//	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;  //ռȼ1
//	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;  //ȼ3
//	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; //IRQͨʹ
//	NVIC_Init(&NVIC_InitStructure);  //ʼNVICĴ					 
}



